/*
	$Id: Display.java 233 2006-06-04 10:49:50Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import funneltree.ClassNode;
import funneltree.FolderNode;
import funneltree.TreeNode;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingUtilities;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
   äΤΥǥץ쥤ɥ
*/
public class Display extends JFrame implements ExceptionListener {

    /** 饹Υĥ꡼ */
    private FunnelTree tree;

    /** ƥȰΥơ֥ */
    private FunnelTable table;

    /** ˥塼С */
    private DisplayMenuBar menuBar;

    /** ơΰȤʤ٥ */
    private JLabel statusLabel;

    /** ƥȥեͥ */
    private Funnel funnel;

    /** ʡ */
    private Runner runner;

    /** 쥷ԤΥ */
    private RecipeLoader recipeLoader;

    /** ץ饤Υ쥷 */
    private Receiver receiver;

    /** FunnelȤ³å */
    private Socket socket;

    /** ץѥƥΥեȥ꡼ */
    private PropertyFactory propertyFactory;

    /**
       UIåɤǤϤʤåɤ㳰ȯȤ˸ƤӽФޤ

       åȤ򥯥ơǥץ쥤ɥĤޤ

       @param e 㳰
    */
    public final void exceptionCaught(final Exception e) {
	e.printStackTrace();
	SwingUtilities.invokeLater(new Runnable() {
	    public void run() {
		close();
	    }
	});
    }

    /**
       ǥץ쥤ɥޤ

       @param s å
       @throws IOException åȤϤȯ㳰
       @throws ProtocolException ץȥ㳰
    */
    public Display(final Socket s) throws ProtocolException, IOException {
	super("Auditor");
	Thread titleChanger = new Thread(new Runnable() {
	    public void run() {
		InetAddress addr = s.getInetAddress();
		if (addr == null) {
		    return;
		}
		final String ip = addr.getHostAddress();
		SwingUtilities.invokeLater(new Runnable() {
		    public void run() {
			setTitle("Auditor: " + ip);
		    }
		});
		final String hostname = addr.getCanonicalHostName();
		SwingUtilities.invokeLater(new Runnable() {
		    public void run() {
			setTitle("Auditor: " + hostname);
		    }
		});
	    }
	});
	titleChanger.start();

	addWindowListener(new WindowAdapter()  {
	    public void windowClosing(final WindowEvent ev) {
		close();
	    }
	});
	menuBar = new DisplayMenuBar(this);
	menuBar.setSelected(false);
	setJMenuBar(menuBar);

	socket = s;
	DataInputStream in = new DataInputStream(
	    new BufferedInputStream(s.getInputStream()));
	DataOutputStream out = new DataOutputStream(
	    new BufferedOutputStream(s.getOutputStream()));
	int size = in.readInt();
	byte[] recipe = new byte[size];
	in.readFully(recipe, 0, recipe.length);

	funnel = new Funnel();
	funnel.setRecipe(recipe);
	funnel.addFunnelListener(new FunnelListener() {
	    public void recipeChanged() {
	    }
	    public void selectionChanged() {
	    }
	    public void statusChanged(final Test t) {
		if (t.getStatus() != Test.RUNNING) {
		    return;
		}
		setRunningState(t);
	    }
	    public void filterChanged() {
	    }
	    public void sortingChanged() {
	    }
	});
	receiver = new Receiver(in, this);
	receiver.start();
	runner = new Runner(this, receiver, out, funnel, this);
	recipeLoader = new RecipeLoader(this, receiver, out, funnel, this);
	propertyFactory = new PropertyFactory(this);

	final JPopupMenu popup = new JPopupMenu();
	popup.add(new AbstractAction("Property") {
	    public void actionPerformed(final ActionEvent ev) {
		TreeNode node = tree.getSelectedNode();
		String nodeName = node.getNodeName();
		String desc = funnel.getDescription(nodeName);
		propertyFactory.open(nodeName, desc);
	    }
	});

	tree = new FunnelTree(funnel);
	tree.setFunnelTreeListener(new FunnelTreeListener() {
	    public void treeNodeSelected(final TreeNode node) {
		if (node instanceof ClassNode) {
		    tree.setComponentPopupMenu(popup);
		    funnel.setClassFilter(node.getNodeName());
		} else if (node instanceof FolderNode) {
		    tree.setComponentPopupMenu(null);
		    funnel.setDefaultFilter();
		}
	    }
	});

	table = new FunnelTable(funnel);
	ListSelectionModel sm = table.getSelectionModel();
	sm.addListSelectionListener(new ListSelectionListener() {
	    public void valueChanged(final ListSelectionEvent ev) {
		menuBar.setSelected(table.getSelectedRowCount() > 0);
	    }
	});

        JSplitPane pane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
					 new JScrollPane(tree),
					 new JScrollPane(table));
        pane.setContinuousLayout(true);
	statusLabel = new JLabel(" ");

	Container panel = getContentPane();
	panel.setLayout(new BorderLayout());
	panel.add(pane, BorderLayout.CENTER);
	panel.add(statusLabel, BorderLayout.SOUTH);

	pack();
        setLocationByPlatform(true);
    }

    /**
       ¹ΥƥȤ˱ơ桼˻ŪʥեɥХåͿ
       

       ơ˼¹ΥƥȤΥ饹̾ȥ᥽å̾ɽޤ
       ޤƥȥեͥΥơ֥ˤ¹ΥƥȤιԤ
       ֤ˤޤ

       @param t ¹Υƥ
    */
    private void setRunningState(final Test t) {
	/*
	  SwingUtilities.invokeLater()ѤˡΥƥ
	  RunnerΥåɡˤJTable#changeSelection()ľܸƤӽ
	  ȡAWTΥ٥ȥåɤȱǥåä
	  ʥǥåɥåơˤޤä
	*/
	SwingUtilities.invokeLater(new Runnable() {
	    public void run() {
		statusLabel.setText(" " + t.getClassName()
				    + "#" + t.getMethodName());
		int row = funnel.getIndex(t);
		if (row < 0) {
		    return;
		}
		table.changeSelection(row, FunnelTable.COL_CHECK,
				      false, false);
	    }
	});
    }

    /**
       ơ֥򤵤ƤƥȤּ¹Ԥоݡפˤ뤫ɤ
       ꤷޤ

       @param b ¹Ԥоݤˤʤ뤫ɤ
    */
    public final void changeMarks(final boolean b) {
	int[] rows = table.getSelectedRows();
	for (int r : rows) {
	    funnel.getTest(r).setSelected(b);
	}
    }

    /**
       ǥץ쥤ɥĤåȤ򥯥ޤ

       Υ᥽åɤƤӽФ塢Υե졼ϥ١쥯
       оݤˤʤޤ
    */
    public final void close() {
	setVisible(false);
	dispose();
	synchronized (socket) {
	    if (!socket.isOutputShutdown()) {
		try {
		    socket.shutdownOutput();
		} catch (IOException e) {
		    e.printStackTrace();
		}
	    }
	}
	try {
	    socket.close();
	} catch (IOException e) {
	    e.printStackTrace();
	}
    }

    /**
       ƥȤμ¹Ԥ򳫻Ϥޤ

       ƥȤμ¹ԤοĽɽɽޤ
    */
    public final void start() {
	runner.show(new Runnable() {
	    public void run() {
		statusLabel.setText(" ");
	    }
	});
    }

    /**
       쥷ԤƼޤ

       쥷ԼοĽɽɽޤ
    */
    public final void reload() {
	propertyFactory.closeAll();
	statusLabel.setText(" Reloading...");
	recipeLoader.show(new Runnable() {
	    public void run() {
		statusLabel.setText(" ");
	    }
	});
    }
}
