/*
	$Id: ArrayStack.c 97 2006-03-01 13:11:45Z syl $

	Copyright (C) 2001 Syllabub
	Maroontress Fast Software.
*/

#include <stdlib.h>
#include "impl/Stack.h"
#include "impl/ArrayStack.h"

static void
ArrayStack_free(struct Stack *s)
{
    free(s->top.cell);
    free(s);
}

static int
ArrayStack_push(struct Stack *s, struct StackCell *c)
{
    if (s->nodes == s->capacity) {
        return STACK_ERROR;
    }
    s->top.cell[s->nodes] = c;
    ++(s->nodes);
    return STACK_SUCCESS;
}

static struct StackCell *
ArrayStack_pop(struct Stack *s)
{
    if (s->nodes == 0)
	return NULL;
    --(s->nodes);
    return s->top.cell[s->nodes];
}

static struct StackCell *
ArrayStack_top(struct Stack *s)
{
    return (s->nodes == 0) ? NULL : s->top.cell[s->nodes - 1];
}

struct Stack *
impl_ArrayStack_create(int n)
{
    struct Stack *s;

    if ((s = (struct Stack *)malloc(sizeof(struct Stack))) == NULL)
        return NULL;
    if ((s->top.cell = (struct StackCell **)malloc(sizeof(struct StackCell *)
						   * n)) == NULL) {
	free(s);
        return NULL;
    }
    s->nodes = 0;
    s->capacity = n;
    s->free = ArrayStack_free;
    s->push = ArrayStack_push;
    s->pop = ArrayStack_pop;
    s->peek = ArrayStack_top;
    return s;
}
