/*
	$Id: InputStream.c 104 2006-03-02 15:35:08Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

#include <stdlib.h>
#include "InputStream.h"
#include "impl/InputStream.h"

ssize_t
InputStream_read(union InputStream in, void *data, size_t size)
{
    return in.impl->read(in.impl, data, size);
}

int
InputStream_readFully(union InputStream in, void *top, size_t size)
{
    int s;
    char *data = top;

    while (size > 0 && (s = in.impl->read(in.impl, data, size)) > 0) {
        data += s;
        size -= s;
    }
    return (size > 0) ? -1 : 0;
}

int
InputStream_close(union InputStream in)
{
    return in.impl->close(in.impl);
}
