/*
	$Id: OutputStream.h 104 2006-03-02 15:35:08Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

#ifndef OUTPUTSTREAM_H
#define OUTPUTSTREAM_H

#include <unistd.h>
#include <stdio.h>
#include "tricks.h"

struct impl_Object;
struct impl_OutputStream;

union OutputStream {
    union {
	struct impl_Object *object;
    } super;
    struct impl_OutputStream *impl;
} TRANSPARENT_UNION;

ssize_t OutputStream_write(union OutputStream, const void *, size_t);
int OutputStream_writeFully(union OutputStream, const void *, size_t);
int OutputStream_print(union OutputStream,
		       const char *, ...) FORMAT_PRINTF(2, 3);
int OutputStream_close(union OutputStream);
FILE * OutputStream_getAncientStream(union OutputStream);

#endif /* !OUTPUTSTREAM_H */
